#!/usr/bin/python
# -*- coding: UTF-8 -*-


import os
import codecs
import jieba
import re
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.feature_extraction.text import TfidfVectorizer
from sklearn.model_selection import train_test_split
from sklearn.metrics.scorer import make_scorer
from sklearn import linear_model
from sklearn import metrics 
from time import time
import numpy as np
from scipy import sparse
from sklearn.utils import shuffle
from sys import argv
from sklearn.naive_bayes import MultinomialNB

# a = argv[1]
a = "【 日期 】 19960813 【 版号 】 5 【 标题 】 我国 矿产资源 知多少 已 发现 矿产 一百六十八种 ， 矿床 和 矿点 二十多万 处 【 作者 】 蒋建科 【 正文 】 本报 北京 ８ 月 １ ２ 日讯 记者 蒋建科 报道 ： “ 过去 常说 咱们 国家 地大物博 、 资源 丰富 ， 现在 又 听 广播 、 报纸 说 我们 人均 资源 太 少 ， 不知 这次 国际 地质 大会 能 有 啥 说道 ？ ” 正在 京城 举办 的 第三十届 国际 地质 大会 也 引起 了 广大 市民 的 关注 和 议论 。 为此 ， 记者 走访 了 大会 有关 部门 。 据介绍 ， 中国 目前 有 ９ ５ ％ 以上 的 一次性 能源 、 ８ ０ ％ 以上 的 工业原料 和 大部分 农业 生产资料 均 来自 于 矿产资源 。 截至 １ ９ ９ ４ 年底 ， 中国 已 发现 矿产 １ ６ ８ 种 ， 矿床 和 矿点 ２ ０ 多万 处 ， 其中 具有 探明储量 的 矿产 达 １ ５ １ 种 ， 矿产地 ２ ． ３ 万多处 ， 可以 说 中国 是 世界 上 矿种 比较 齐全 、 矿产 储量 可观 的 少数几个 国家 之一 。 目前 探明 的 矿产资源 基本 保证 了 国家 经济 建设 的 需求 。 专家 们 指出 ， 尽管 中国 矿产资源 总量 大 ， 但 人均 占有量 仅为 世界 人均 占有量 的 ５ ８ ％ 。 按 统一 的 国际 可比价格 ， 中国 矿产资源 潜在 总值 居 世界 第三 ， 但 人均 潜在 总值 仅居 世界 第五十三 位 ， 而且 矿产资源 还 存在 着 分布 不均 、 一些 矿产 质量 不 优等 特点 。 从 已 探明 的 储量 看 ， 煤炭 、 钨 、 锡 、 锑 、 钼 、 汞 等 储量 大 ， 开发 条件 好 ， 在世界上 占有优势 。 一些 大宗 矿产 ， 如铁 、 锰 、 铜 、 钾盐 、 金刚石 等 已 探明储量 不足 ， 不能 满足 当前 和 ２ ０ ０ ０ 年 建设 的 需要 。 中国 幅员辽阔 ， 成矿 条件 比较 优越 ， 矿产资源 远景 相当可观 ， 已 发现 可 作为 进一步 找矿 线索 的 矿点 、 矿化 点有 ２ ０ 多万 处 。 中国 已 探明 的 矿产资源 总量 较大 ， 约 占 世界 的 １ ２ ％ ， 仅次于 美国 和 俄罗斯 。 以 中国 ４ ５ 种 主要 矿产 保有储量 与 世界 矿产 储量 相 比较 ， 有 １ １ 种 占 世界 第一位 ， 有 １ ２ 种 占 世界 第二位 。 按 统一 的 国际 市场 可比价格 ， 以 １ ９ ９ ４ 年 中国 矿产资源 保有量 潜在 价值 计算 ， 中国 矿产资源 潜在 总值 为 ９ １ ． ６ ６ 万亿元 ， 居 世界 第三位 "
test_x = [a]



def split_data_with_label(corpus):
    input_x = []
    input_y = []
 
    tag = []
    if os.path.isfile(corpus):
        with codecs.open(corpus, 'r') as f:
            for line in f:
                tag.append(line)
 
    else:
        for docs in corpus:
            for doc in docs:
                tag.append(doc)

    tag = shuffle(tag)
    for doc in tag:
        index = doc.find(' ')
        input_y.append(doc[:index])
        input_x.append(doc[index + 1 :])

    return [input_x, input_y]
	
def feature_extractor():
   
    return TfidfVectorizer(token_pattern='\w', ngram_range=(1,2), max_df=0.5, min_df=0.0, stop_words=["是", "的"])
	

def fit_and_predicted_use_CV(x_path, y_path, test_x, penalty='l2', solver='lbfgs', cv=10): 

    # clf = linear_model.LogisticRegressionCV(penalty=penalty, solver=solver, n_jobs=-1, cv=cv,multi_class ='auto',max_iter = 500).fit(x_path, y_path)
    clf = MultinomialNB().fit(x_path, y_path)

    predicted = clf.predict_proba(test_x)
    y_path = np.unique(y_path)
    i = 0
    temp_index_num = 0
    final_rank = []
    while(i<5):
        temp_index_num = np.argmax(predicted)
        final_rank.append(y_path[temp_index_num])
        predicted[0][temp_index_num] = 0
        i = i+1
    return final_rank
     


def main(test_x):
    corpus = split_data_with_label('H:\\thu_data_all2')
    input_x, y = corpus
    count_vec = feature_extractor()
    train_x = count_vec.fit_transform(input_x)
    test_x1 = count_vec.transform(test_x)
    return fit_and_predicted_use_CV(train_x, y, test_x1)


